module.exports = (grunt) ->
  # Project configuration.
  grunt.loadNpmTasks 'grunt-contrib-coffee'
  grunt.initConfig
    pkg: grunt.file.readJSON("package.json")
    meta: 
      banner: '/*! <%= pkg.name %> - v<%= pkg.version %> - ' + '<%= grunt.template.today("yyyy-mm-dd") %> */'
      banner_web : '/*! <%= pkg.name %> for web - v<%= pkg.version %> - ' + '<%= grunt.template.today("yyyy-mm-dd") %> */'
      banner_web_min : '/*! <%= pkg.name %> for web - v<%= pkg.version %> - ' + '<%= grunt.template.today("yyyy-mm-dd") %> <%= pkg.homepage %> */'
      website: '/*! <%= pkg.homepage %> */'
  
    coffee:
      options:
        bare: on
      compile: 
        files: 
          'lib/web/utilxi.web.js': ['src/web/utilxi.web.coffee']
          'lib/node/utilxi.js' : 'src/node/utilxi.coffee'
    min :
      web:
        dest: 'lib/web/utilxi.web.min.js' 
        src : ['<banner:meta.banner_web_min>', 'lib/web/utilxi.web.js'] 
    concat:
      web:
        src: ['<banner:meta.banner_web>','<banner:meta.website>', 'node_modules/underscore/underscore.js','lib/web/utilxi.web.js']
        dest: 'lib/web/utilxi.web.js'
      node: 
        src: ['<banner>','<website>','lib/node/utilxi.js']
        dest: 'lib/node/utilxi.js'
    clean :
      build: ['lib/web', 'lib/node']
     
  grunt.registerTask('build_all', ['coffee', 'concat', 'min']);
  grunt.registerTask('default', ['build_all']);
  grunt.registerMultiTask(
    'clean', 'clean stuff.', 
    () ->
      grunt.log.writeln(this.data);
      this.data.forEach((filepath) ->
        grunt.log.write('Cleaning "' + filepath + '"...\n')
        grunt.file.recurse filepath, 
        (abspath, rootdir, subdir, filename)->
          absname = abspath + filename
          grunt.log.write absname + '\n'
          fs = require 'fs'
          fs.unlink(
            abspath, 
            (err) ->
              if err then grunt.log.write err
              else grunt.log.write("YES")
          )
        grunt.log.ok()
      )
  )